another four IPv6 scenarios fully demonstrate ip6tables firewall use
authorAndreas Steffen <andreas.steffen@strongswan.org>
Thu, 8 Nov 2007 11:59:29 +0000 (11:59 -0000)
committerAndreas Steffen <andreas.steffen@strongswan.org>
Thu, 8 Nov 2007 11:59:29 +0000 (11:59 -0000)
32 files changed:
testing/tests/ipv6/host2host-ikev2/description.txt
testing/tests/ipv6/host2host-ikev2/hosts/moon/etc/init.d/iptables [new file with mode: 0755]
testing/tests/ipv6/host2host-ikev2/hosts/moon/etc/ipsec.conf
testing/tests/ipv6/host2host-ikev2/hosts/sun/etc/init.d/iptables [new file with mode: 0755]
testing/tests/ipv6/host2host-ikev2/hosts/sun/etc/ipsec.conf
testing/tests/ipv6/host2host-ikev2/posttest.dat
testing/tests/ipv6/host2host-ikev2/pretest.dat
testing/tests/ipv6/net2net-ikev2/description.txt
testing/tests/ipv6/net2net-ikev2/hosts/moon/etc/init.d/iptables [new file with mode: 0755]
testing/tests/ipv6/net2net-ikev2/hosts/moon/etc/ipsec.conf
testing/tests/ipv6/net2net-ikev2/hosts/sun/etc/init.d/iptables [new file with mode: 0755]
testing/tests/ipv6/net2net-ikev2/hosts/sun/etc/ipsec.conf
testing/tests/ipv6/net2net-ikev2/posttest.dat
testing/tests/ipv6/net2net-ikev2/pretest.dat
testing/tests/ipv6/rw-ikev1/description.txt
testing/tests/ipv6/rw-ikev1/hosts/carol/etc/init.d/iptables [new file with mode: 0755]
testing/tests/ipv6/rw-ikev1/hosts/carol/etc/ipsec.conf
testing/tests/ipv6/rw-ikev1/hosts/moon/etc/init.d/iptables [new file with mode: 0755]
testing/tests/ipv6/rw-ikev1/hosts/moon/etc/ipsec.conf
testing/tests/ipv6/rw-ikev1/posttest.dat
testing/tests/ipv6/rw-ikev1/pretest.dat
testing/tests/ipv6/rw-ikev2/description.txt [new file with mode: 0644]
testing/tests/ipv6/rw-ikev2/evaltest.dat [new file with mode: 0644]
testing/tests/ipv6/rw-ikev2/hosts/carol/etc/init.d/iptables [new file with mode: 0755]
testing/tests/ipv6/rw-ikev2/hosts/carol/etc/ipsec.conf [new file with mode: 0755]
testing/tests/ipv6/rw-ikev2/hosts/dave/etc/init.d/iptables [new file with mode: 0755]
testing/tests/ipv6/rw-ikev2/hosts/dave/etc/ipsec.conf [new file with mode: 0755]
testing/tests/ipv6/rw-ikev2/hosts/moon/etc/init.d/iptables [new file with mode: 0755]
testing/tests/ipv6/rw-ikev2/hosts/moon/etc/ipsec.conf [new file with mode: 0755]
testing/tests/ipv6/rw-ikev2/posttest.dat [new file with mode: 0644]
testing/tests/ipv6/rw-ikev2/pretest.dat [new file with mode: 0644]
testing/tests/ipv6/rw-ikev2/test.conf [new file with mode: 0644]

index c59b32a..b52c4ca 100644 (file)
@@ -1,3 +1,5 @@
 An IPv6 ESP connection between the hosts <b>moon</b> and <b>sun</b> is successfully set up.
-The authentication is based on X.509 certificates. In order to test the host-to-host tunnel
-<b>moon</b> sends an IPv6 ICMP request to <b>sun</b> using the ping6 command.
+The authentication is based on X.509 certificates. Upon the successful establishment of
+the IPsec tunnel, <b>leftfirewall=yes</b> automatically inserts ip6tables-based firewall
+rules that let pass the tunneled traffic. In order to test both the host-to-host tunnel
+and the firewall rules, <b>moon</b> sends an IPv6 ICMP request to <b>sun</b> using the ping6 command.
diff --git a/testing/tests/ipv6/host2host-ikev2/hosts/moon/etc/init.d/iptables b/testing/tests/ipv6/host2host-ikev2/hosts/moon/etc/init.d/iptables
new file mode 100755 (executable)
index 0000000..03fdd4a
--- /dev/null
@@ -0,0 +1,107 @@
+#!/sbin/runscript
+# Copyright 1999-2004 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+opts="start stop reload"
+
+depend() {
+       before net
+       need logger
+}
+
+start() {
+       ebegin "Starting firewall"
+
+       # enable IP forwarding
+       echo 1 > /proc/sys/net/ipv6/conf/all/forwarding
+       echo 1 > /proc/sys/net/ipv4/ip_forward
+       
+       # default policy is DROP
+       /sbin/iptables -P INPUT DROP
+       /sbin/iptables -P OUTPUT DROP
+       /sbin/iptables -P FORWARD DROP
+
+       /sbin/ip6tables -P INPUT DROP
+       /sbin/ip6tables -P OUTPUT DROP
+       /sbin/ip6tables -P FORWARD DROP
+
+       # allow esp
+       ip6tables -A INPUT  -i eth0 -p 50 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p 50 -j ACCEPT
+
+       # allow IKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 500 --dport 500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 500 --sport 500 -j ACCEPT
+
+       # allow MobIKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 4500 --dport 4500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 4500 --sport 4500 -j ACCEPT
+
+       # allow last UDP fragment
+       ip6tables -A INPUT -i eth0 -p udp -m frag --fraglast -j ACCEPT
+
+       # allow ICMPv6 neighbor-solicitations
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       
+       # allow ICMPv6 neighbor-advertisements
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+
+       # allow crl fetch from winnetou
+       iptables -A INPUT  -i eth0 -p tcp --sport 80 -s PH_IP_WINNETOU -j ACCEPT
+       iptables -A OUTPUT -o eth0 -p tcp --dport 80 -d PH_IP_WINNETOU -j ACCEPT
+
+       # allow ssh
+       iptables -A INPUT  -p tcp --dport 22 -j ACCEPT
+       iptables -A OUTPUT -p tcp --sport 22 -j ACCEPT
+
+       # log dropped packets
+       ip6tables -A INPUT  -j LOG --log-prefix " IN: "
+       ip6tables -A OUTPUT -j LOG --log-prefix " OUT: "
+
+       eend $?
+}
+
+stop() {
+       ebegin "Stopping firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+
+                       /sbin/ipables -F -t $a
+                       /sbin/iptables -X -t $a
+       
+                       if [ $a == nat ]; then
+                               /sbin/iptables -t nat -P PREROUTING ACCEPT
+                               /sbin/iptables -t nat -P POSTROUTING ACCEPT
+                               /sbin/iptables -t nat -P OUTPUT ACCEPT
+                       elif [ $a == mangle ]; then
+                               /sbin/iptables -t mangle -P PREROUTING ACCEPT
+                               /sbin/iptables -t mangle -P INPUT ACCEPT
+                               /sbin/iptables -t mangle -P FORWARD ACCEPT
+                               /sbin/iptables -t mangle -P OUTPUT ACCEPT
+                               /sbin/iptables -t mangle -P POSTROUTING ACCEPT
+                       elif [ $a == filter ]; then
+                               /sbin/ip6tables -t filter -P INPUT ACCEPT
+                               /sbin/ip6tables -t filter -P FORWARD ACCEPT
+                               /sbin/ip6tables -t filter -P OUTPUT ACCEPT
+
+                               /sbin/iptables -t filter -P INPUT ACCEPT
+                               /sbin/iptables -t filter -P FORWARD ACCEPT
+                               /sbin/iptables -t filter -P OUTPUT ACCEPT
+                       fi
+               done
+       eend $?
+}
+
+reload() {
+       ebegin "Flushing firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+               done;
+        eend $?
+       start
+}
+
index da750b1..ccc8037 100755 (executable)
@@ -2,6 +2,7 @@
 
 config setup
        strictcrlpolicy=no
+       crlcheckinterval=180
        plutostart=no
 
 conn %default
diff --git a/testing/tests/ipv6/host2host-ikev2/hosts/sun/etc/init.d/iptables b/testing/tests/ipv6/host2host-ikev2/hosts/sun/etc/init.d/iptables
new file mode 100755 (executable)
index 0000000..03fdd4a
--- /dev/null
@@ -0,0 +1,107 @@
+#!/sbin/runscript
+# Copyright 1999-2004 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+opts="start stop reload"
+
+depend() {
+       before net
+       need logger
+}
+
+start() {
+       ebegin "Starting firewall"
+
+       # enable IP forwarding
+       echo 1 > /proc/sys/net/ipv6/conf/all/forwarding
+       echo 1 > /proc/sys/net/ipv4/ip_forward
+       
+       # default policy is DROP
+       /sbin/iptables -P INPUT DROP
+       /sbin/iptables -P OUTPUT DROP
+       /sbin/iptables -P FORWARD DROP
+
+       /sbin/ip6tables -P INPUT DROP
+       /sbin/ip6tables -P OUTPUT DROP
+       /sbin/ip6tables -P FORWARD DROP
+
+       # allow esp
+       ip6tables -A INPUT  -i eth0 -p 50 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p 50 -j ACCEPT
+
+       # allow IKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 500 --dport 500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 500 --sport 500 -j ACCEPT
+
+       # allow MobIKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 4500 --dport 4500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 4500 --sport 4500 -j ACCEPT
+
+       # allow last UDP fragment
+       ip6tables -A INPUT -i eth0 -p udp -m frag --fraglast -j ACCEPT
+
+       # allow ICMPv6 neighbor-solicitations
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       
+       # allow ICMPv6 neighbor-advertisements
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+
+       # allow crl fetch from winnetou
+       iptables -A INPUT  -i eth0 -p tcp --sport 80 -s PH_IP_WINNETOU -j ACCEPT
+       iptables -A OUTPUT -o eth0 -p tcp --dport 80 -d PH_IP_WINNETOU -j ACCEPT
+
+       # allow ssh
+       iptables -A INPUT  -p tcp --dport 22 -j ACCEPT
+       iptables -A OUTPUT -p tcp --sport 22 -j ACCEPT
+
+       # log dropped packets
+       ip6tables -A INPUT  -j LOG --log-prefix " IN: "
+       ip6tables -A OUTPUT -j LOG --log-prefix " OUT: "
+
+       eend $?
+}
+
+stop() {
+       ebegin "Stopping firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+
+                       /sbin/ipables -F -t $a
+                       /sbin/iptables -X -t $a
+       
+                       if [ $a == nat ]; then
+                               /sbin/iptables -t nat -P PREROUTING ACCEPT
+                               /sbin/iptables -t nat -P POSTROUTING ACCEPT
+                               /sbin/iptables -t nat -P OUTPUT ACCEPT
+                       elif [ $a == mangle ]; then
+                               /sbin/iptables -t mangle -P PREROUTING ACCEPT
+                               /sbin/iptables -t mangle -P INPUT ACCEPT
+                               /sbin/iptables -t mangle -P FORWARD ACCEPT
+                               /sbin/iptables -t mangle -P OUTPUT ACCEPT
+                               /sbin/iptables -t mangle -P POSTROUTING ACCEPT
+                       elif [ $a == filter ]; then
+                               /sbin/ip6tables -t filter -P INPUT ACCEPT
+                               /sbin/ip6tables -t filter -P FORWARD ACCEPT
+                               /sbin/ip6tables -t filter -P OUTPUT ACCEPT
+
+                               /sbin/iptables -t filter -P INPUT ACCEPT
+                               /sbin/iptables -t filter -P FORWARD ACCEPT
+                               /sbin/iptables -t filter -P OUTPUT ACCEPT
+                       fi
+               done
+       eend $?
+}
+
+reload() {
+       ebegin "Flushing firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+               done;
+        eend $?
+       start
+}
+
index bad82a8..1ec8b49 100755 (executable)
@@ -2,6 +2,7 @@
 
 config setup
        strictcrlpolicy=no
+       crlcheckinterval=180
        plutostart=no
 
 conn %default
index dff1817..5a9150b 100644 (file)
@@ -1,2 +1,4 @@
 moon::ipsec stop
 sun::ipsec stop
+moon::/etc/init.d/iptables stop 2> /dev/null
+sun::/etc/init.d/iptables stop 2> /dev/null
index 4707af0..3536fd8 100644 (file)
@@ -1,3 +1,5 @@
+moon::/etc/init.d/iptables start 2> /dev/null
+sun::/etc/init.d/iptables start 2> /dev/null
 moon::ipsec start
 sun::ipsec start
 moon::sleep 2 
index 4c1b5c8..5952ecc 100644 (file)
@@ -1,4 +1,6 @@
 An IPv6 ESP tunnel connection between the gateways <b>moon</b> and <b>sun</b> is successfully set up.
 It connects the two subnets hiding behind their respective gateways. The authentication is based on
-X.509 certificates. In order to test the net-to-net tunnel client <b>alice</b> behind <b>moon</b>
+X.509 certificates. Upon the successful establishment of the IPsec tunnel, <b>leftfirewall=yes</b>
+automatically inserts ip6tables-based firewall rules that let pass the tunneled traffic.
+In order to test both the net-to-net tunnel and the firewall rules, client <b>alice</b> behind <b>moon</b>
 sends an IPv6 ICMP request to client <b>bob</b> behind <b>sun</b> using the ping6 command.
diff --git a/testing/tests/ipv6/net2net-ikev2/hosts/moon/etc/init.d/iptables b/testing/tests/ipv6/net2net-ikev2/hosts/moon/etc/init.d/iptables
new file mode 100755 (executable)
index 0000000..03fdd4a
--- /dev/null
@@ -0,0 +1,107 @@
+#!/sbin/runscript
+# Copyright 1999-2004 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+opts="start stop reload"
+
+depend() {
+       before net
+       need logger
+}
+
+start() {
+       ebegin "Starting firewall"
+
+       # enable IP forwarding
+       echo 1 > /proc/sys/net/ipv6/conf/all/forwarding
+       echo 1 > /proc/sys/net/ipv4/ip_forward
+       
+       # default policy is DROP
+       /sbin/iptables -P INPUT DROP
+       /sbin/iptables -P OUTPUT DROP
+       /sbin/iptables -P FORWARD DROP
+
+       /sbin/ip6tables -P INPUT DROP
+       /sbin/ip6tables -P OUTPUT DROP
+       /sbin/ip6tables -P FORWARD DROP
+
+       # allow esp
+       ip6tables -A INPUT  -i eth0 -p 50 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p 50 -j ACCEPT
+
+       # allow IKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 500 --dport 500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 500 --sport 500 -j ACCEPT
+
+       # allow MobIKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 4500 --dport 4500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 4500 --sport 4500 -j ACCEPT
+
+       # allow last UDP fragment
+       ip6tables -A INPUT -i eth0 -p udp -m frag --fraglast -j ACCEPT
+
+       # allow ICMPv6 neighbor-solicitations
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       
+       # allow ICMPv6 neighbor-advertisements
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+
+       # allow crl fetch from winnetou
+       iptables -A INPUT  -i eth0 -p tcp --sport 80 -s PH_IP_WINNETOU -j ACCEPT
+       iptables -A OUTPUT -o eth0 -p tcp --dport 80 -d PH_IP_WINNETOU -j ACCEPT
+
+       # allow ssh
+       iptables -A INPUT  -p tcp --dport 22 -j ACCEPT
+       iptables -A OUTPUT -p tcp --sport 22 -j ACCEPT
+
+       # log dropped packets
+       ip6tables -A INPUT  -j LOG --log-prefix " IN: "
+       ip6tables -A OUTPUT -j LOG --log-prefix " OUT: "
+
+       eend $?
+}
+
+stop() {
+       ebegin "Stopping firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+
+                       /sbin/ipables -F -t $a
+                       /sbin/iptables -X -t $a
+       
+                       if [ $a == nat ]; then
+                               /sbin/iptables -t nat -P PREROUTING ACCEPT
+                               /sbin/iptables -t nat -P POSTROUTING ACCEPT
+                               /sbin/iptables -t nat -P OUTPUT ACCEPT
+                       elif [ $a == mangle ]; then
+                               /sbin/iptables -t mangle -P PREROUTING ACCEPT
+                               /sbin/iptables -t mangle -P INPUT ACCEPT
+                               /sbin/iptables -t mangle -P FORWARD ACCEPT
+                               /sbin/iptables -t mangle -P OUTPUT ACCEPT
+                               /sbin/iptables -t mangle -P POSTROUTING ACCEPT
+                       elif [ $a == filter ]; then
+                               /sbin/ip6tables -t filter -P INPUT ACCEPT
+                               /sbin/ip6tables -t filter -P FORWARD ACCEPT
+                               /sbin/ip6tables -t filter -P OUTPUT ACCEPT
+
+                               /sbin/iptables -t filter -P INPUT ACCEPT
+                               /sbin/iptables -t filter -P FORWARD ACCEPT
+                               /sbin/iptables -t filter -P OUTPUT ACCEPT
+                       fi
+               done
+       eend $?
+}
+
+reload() {
+       ebegin "Flushing firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+               done;
+        eend $?
+       start
+}
+
index f6fff76..651e17e 100755 (executable)
@@ -2,6 +2,7 @@
 
 config setup
        strictcrlpolicy=no
+       crlcheckinterval=180
        plutostart=no
 
 conn %default
@@ -25,4 +26,3 @@ conn host-host
        right=PH_IP6_SUN
        rightid=@sun.strongswan.org
        auto=add
-
diff --git a/testing/tests/ipv6/net2net-ikev2/hosts/sun/etc/init.d/iptables b/testing/tests/ipv6/net2net-ikev2/hosts/sun/etc/init.d/iptables
new file mode 100755 (executable)
index 0000000..03fdd4a
--- /dev/null
@@ -0,0 +1,107 @@
+#!/sbin/runscript
+# Copyright 1999-2004 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+opts="start stop reload"
+
+depend() {
+       before net
+       need logger
+}
+
+start() {
+       ebegin "Starting firewall"
+
+       # enable IP forwarding
+       echo 1 > /proc/sys/net/ipv6/conf/all/forwarding
+       echo 1 > /proc/sys/net/ipv4/ip_forward
+       
+       # default policy is DROP
+       /sbin/iptables -P INPUT DROP
+       /sbin/iptables -P OUTPUT DROP
+       /sbin/iptables -P FORWARD DROP
+
+       /sbin/ip6tables -P INPUT DROP
+       /sbin/ip6tables -P OUTPUT DROP
+       /sbin/ip6tables -P FORWARD DROP
+
+       # allow esp
+       ip6tables -A INPUT  -i eth0 -p 50 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p 50 -j ACCEPT
+
+       # allow IKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 500 --dport 500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 500 --sport 500 -j ACCEPT
+
+       # allow MobIKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 4500 --dport 4500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 4500 --sport 4500 -j ACCEPT
+
+       # allow last UDP fragment
+       ip6tables -A INPUT -i eth0 -p udp -m frag --fraglast -j ACCEPT
+
+       # allow ICMPv6 neighbor-solicitations
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       
+       # allow ICMPv6 neighbor-advertisements
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+
+       # allow crl fetch from winnetou
+       iptables -A INPUT  -i eth0 -p tcp --sport 80 -s PH_IP_WINNETOU -j ACCEPT
+       iptables -A OUTPUT -o eth0 -p tcp --dport 80 -d PH_IP_WINNETOU -j ACCEPT
+
+       # allow ssh
+       iptables -A INPUT  -p tcp --dport 22 -j ACCEPT
+       iptables -A OUTPUT -p tcp --sport 22 -j ACCEPT
+
+       # log dropped packets
+       ip6tables -A INPUT  -j LOG --log-prefix " IN: "
+       ip6tables -A OUTPUT -j LOG --log-prefix " OUT: "
+
+       eend $?
+}
+
+stop() {
+       ebegin "Stopping firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+
+                       /sbin/ipables -F -t $a
+                       /sbin/iptables -X -t $a
+       
+                       if [ $a == nat ]; then
+                               /sbin/iptables -t nat -P PREROUTING ACCEPT
+                               /sbin/iptables -t nat -P POSTROUTING ACCEPT
+                               /sbin/iptables -t nat -P OUTPUT ACCEPT
+                       elif [ $a == mangle ]; then
+                               /sbin/iptables -t mangle -P PREROUTING ACCEPT
+                               /sbin/iptables -t mangle -P INPUT ACCEPT
+                               /sbin/iptables -t mangle -P FORWARD ACCEPT
+                               /sbin/iptables -t mangle -P OUTPUT ACCEPT
+                               /sbin/iptables -t mangle -P POSTROUTING ACCEPT
+                       elif [ $a == filter ]; then
+                               /sbin/ip6tables -t filter -P INPUT ACCEPT
+                               /sbin/ip6tables -t filter -P FORWARD ACCEPT
+                               /sbin/ip6tables -t filter -P OUTPUT ACCEPT
+
+                               /sbin/iptables -t filter -P INPUT ACCEPT
+                               /sbin/iptables -t filter -P FORWARD ACCEPT
+                               /sbin/iptables -t filter -P OUTPUT ACCEPT
+                       fi
+               done
+       eend $?
+}
+
+reload() {
+       ebegin "Flushing firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+               done;
+        eend $?
+       start
+}
+
index 64b341a..4ba0bcb 100755 (executable)
@@ -2,6 +2,7 @@
 
 config setup
        strictcrlpolicy=no
+       crlcheckinterval=180
        plutostart=no
 
 conn %default
index f527995..4c95e2a 100644 (file)
@@ -4,3 +4,5 @@ alice::"ip route del fec2:\:/16 via fec1:\:1"
 moon::"ip route del fec2:\:/16 via fec0:\:2"
 sun::"ip route del fec1:\:/16 via fec0:\:1"
 bob::"ip route del fec1:\:/16 via fec2:\:1"
+moon::/etc/init.d/iptables stop 2> /dev/null
+sun::/etc/init.d/iptables stop 2> /dev/null
index 347a27b..e360bfb 100644 (file)
@@ -1,5 +1,5 @@
-moon::echo "1" >/proc/sys/net/ipv6/conf/all/forwarding
-sun::echo "1" >/proc/sys/net/ipv6/conf/all/forwarding
+moon::/etc/init.d/iptables start 2> /dev/null
+sun::/etc/init.d/iptables start 2> /dev/null
 alice::"ip route add fec2:\:/16 via fec1:\:1"
 moon::"ip route add fec2:\:/16 via fec0:\:2"
 sun::"ip route add fec1:\:/16 via fec0:\:1"
index 3ec8555..046c4b5 100644 (file)
@@ -1,5 +1,7 @@
 The roadwarrior <b>carol</b> sets up a connection to gateway <b>moon</b>.
-The authentication is based on <b>X.509 certificates</b>.
-In order to test the IPv6 ESP tunnel, <b>carol</b> sends an IPv6 ICMP request
-to the client <b>alice</b> behind the gateway <b>moon</b> using the ping6
-command.
+The authentication is based on <b>X.509 certificates</b>. Upon the successful
+establishment of the IPsec tunnel, <b>leftfirewall=yes</b> automatically inserts
+ip6tables-based firewall rules that let pass the tunneled traffic.
+In order to test both the IPv6 ESP tunnel and the firewall rules, <b>carol</b>
+sends an IPv6 ICMP request to the client <b>alice</b> behind the gateway <b>moon</b>
+using the ping6 command.
diff --git a/testing/tests/ipv6/rw-ikev1/hosts/carol/etc/init.d/iptables b/testing/tests/ipv6/rw-ikev1/hosts/carol/etc/init.d/iptables
new file mode 100755 (executable)
index 0000000..8db1f13
--- /dev/null
@@ -0,0 +1,100 @@
+#!/sbin/runscript
+# Copyright 1999-2004 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+opts="start stop reload"
+
+depend() {
+       before net
+       need logger
+}
+
+start() {
+       ebegin "Starting firewall"
+
+       # enable IP forwarding
+       echo 1 > /proc/sys/net/ipv6/conf/all/forwarding
+       echo 1 > /proc/sys/net/ipv4/ip_forward
+       
+       # default policy is DROP
+       /sbin/iptables -P INPUT DROP
+       /sbin/iptables -P OUTPUT DROP
+       /sbin/iptables -P FORWARD DROP
+
+       /sbin/ip6tables -P INPUT DROP
+       /sbin/ip6tables -P OUTPUT DROP
+       /sbin/ip6tables -P FORWARD DROP
+
+       # allow esp
+       ip6tables -A INPUT  -i eth0 -p 50 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p 50 -j ACCEPT
+
+       # allow IKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 500 --dport 500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 500 --sport 500 -j ACCEPT
+
+       # allow MobIKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 4500 --dport 4500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 4500 --sport 4500 -j ACCEPT
+
+       # allow ICMPv6 neighbor-solicitations
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       
+       # allow ICMPv6 neighbor-advertisements
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+
+       # allow crl fetch from winnetou
+       iptables -A INPUT  -i eth0 -p tcp --sport 80 -s PH_IP_WINNETOU -j ACCEPT
+       iptables -A OUTPUT -o eth0 -p tcp --dport 80 -d PH_IP_WINNETOU -j ACCEPT
+
+       # allow ssh
+       iptables -A INPUT  -p tcp --dport 22 -j ACCEPT
+       iptables -A OUTPUT -p tcp --sport 22 -j ACCEPT
+
+       eend $?
+}
+
+stop() {
+       ebegin "Stopping firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+
+                       /sbin/ipables -F -t $a
+                       /sbin/iptables -X -t $a
+       
+                       if [ $a == nat ]; then
+                               /sbin/iptables -t nat -P PREROUTING ACCEPT
+                               /sbin/iptables -t nat -P POSTROUTING ACCEPT
+                               /sbin/iptables -t nat -P OUTPUT ACCEPT
+                       elif [ $a == mangle ]; then
+                               /sbin/iptables -t mangle -P PREROUTING ACCEPT
+                               /sbin/iptables -t mangle -P INPUT ACCEPT
+                               /sbin/iptables -t mangle -P FORWARD ACCEPT
+                               /sbin/iptables -t mangle -P OUTPUT ACCEPT
+                               /sbin/iptables -t mangle -P POSTROUTING ACCEPT
+                       elif [ $a == filter ]; then
+                               /sbin/ip6tables -t filter -P INPUT ACCEPT
+                               /sbin/ip6tables -t filter -P FORWARD ACCEPT
+                               /sbin/ip6tables -t filter -P OUTPUT ACCEPT
+
+                               /sbin/iptables -t filter -P INPUT ACCEPT
+                               /sbin/iptables -t filter -P FORWARD ACCEPT
+                               /sbin/iptables -t filter -P OUTPUT ACCEPT
+                       fi
+               done
+       eend $?
+}
+
+reload() {
+       ebegin "Flushing firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+               done;
+        eend $?
+       start
+}
+
index 7430f74..753d71c 100755 (executable)
@@ -17,6 +17,7 @@ conn home
        leftnexthop=0::0
        leftcert=carolCert.pem
        leftid=carol@strongswan.org
+       leftfirewall=yes
        right=PH_IP6_MOON
        rightnexthop=0::0
        rightsubnet=fec1::/16
diff --git a/testing/tests/ipv6/rw-ikev1/hosts/moon/etc/init.d/iptables b/testing/tests/ipv6/rw-ikev1/hosts/moon/etc/init.d/iptables
new file mode 100755 (executable)
index 0000000..8db1f13
--- /dev/null
@@ -0,0 +1,100 @@
+#!/sbin/runscript
+# Copyright 1999-2004 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+opts="start stop reload"
+
+depend() {
+       before net
+       need logger
+}
+
+start() {
+       ebegin "Starting firewall"
+
+       # enable IP forwarding
+       echo 1 > /proc/sys/net/ipv6/conf/all/forwarding
+       echo 1 > /proc/sys/net/ipv4/ip_forward
+       
+       # default policy is DROP
+       /sbin/iptables -P INPUT DROP
+       /sbin/iptables -P OUTPUT DROP
+       /sbin/iptables -P FORWARD DROP
+
+       /sbin/ip6tables -P INPUT DROP
+       /sbin/ip6tables -P OUTPUT DROP
+       /sbin/ip6tables -P FORWARD DROP
+
+       # allow esp
+       ip6tables -A INPUT  -i eth0 -p 50 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p 50 -j ACCEPT
+
+       # allow IKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 500 --dport 500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 500 --sport 500 -j ACCEPT
+
+       # allow MobIKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 4500 --dport 4500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 4500 --sport 4500 -j ACCEPT
+
+       # allow ICMPv6 neighbor-solicitations
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       
+       # allow ICMPv6 neighbor-advertisements
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+
+       # allow crl fetch from winnetou
+       iptables -A INPUT  -i eth0 -p tcp --sport 80 -s PH_IP_WINNETOU -j ACCEPT
+       iptables -A OUTPUT -o eth0 -p tcp --dport 80 -d PH_IP_WINNETOU -j ACCEPT
+
+       # allow ssh
+       iptables -A INPUT  -p tcp --dport 22 -j ACCEPT
+       iptables -A OUTPUT -p tcp --sport 22 -j ACCEPT
+
+       eend $?
+}
+
+stop() {
+       ebegin "Stopping firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+
+                       /sbin/ipables -F -t $a
+                       /sbin/iptables -X -t $a
+       
+                       if [ $a == nat ]; then
+                               /sbin/iptables -t nat -P PREROUTING ACCEPT
+                               /sbin/iptables -t nat -P POSTROUTING ACCEPT
+                               /sbin/iptables -t nat -P OUTPUT ACCEPT
+                       elif [ $a == mangle ]; then
+                               /sbin/iptables -t mangle -P PREROUTING ACCEPT
+                               /sbin/iptables -t mangle -P INPUT ACCEPT
+                               /sbin/iptables -t mangle -P FORWARD ACCEPT
+                               /sbin/iptables -t mangle -P OUTPUT ACCEPT
+                               /sbin/iptables -t mangle -P POSTROUTING ACCEPT
+                       elif [ $a == filter ]; then
+                               /sbin/ip6tables -t filter -P INPUT ACCEPT
+                               /sbin/ip6tables -t filter -P FORWARD ACCEPT
+                               /sbin/ip6tables -t filter -P OUTPUT ACCEPT
+
+                               /sbin/iptables -t filter -P INPUT ACCEPT
+                               /sbin/iptables -t filter -P FORWARD ACCEPT
+                               /sbin/iptables -t filter -P OUTPUT ACCEPT
+                       fi
+               done
+       eend $?
+}
+
+reload() {
+       ebegin "Flushing firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+               done;
+        eend $?
+       start
+}
+
index 923ccd6..520b538 100755 (executable)
@@ -18,6 +18,7 @@ conn rw
        leftcert=moonCert.pem
        leftid=@moon.strongswan.org
        leftsubnet=fec1::/16
+       leftfirewall=yes
        right=%any
        rightnexthop=0::0
        auto=add
index 16dac1b..d37b96f 100644 (file)
@@ -1,3 +1,6 @@
 moon::ipsec stop
 carol::ipsec stop
 alice::"ip route del fec0:\:/16 via fec1:\:1"
+carol::"ip route del fec1:\:/16 via fec0:\:1"
+moon::/etc/init.d/iptables stop 2> /dev/null
+carol::/etc/init.d/iptables stop 2> /dev/null
index 3df25e3..2b3bf90 100644 (file)
@@ -1,5 +1,7 @@
-moon::echo "1" >/proc/sys/net/ipv6/conf/all/forwarding
+moon::/etc/init.d/iptables start 2> /dev/null
+carol::/etc/init.d/iptables start 2> /dev/null
 alice::"ip route add fec0:\:/16 via fec1:\:1"
+carol::"ip route add fec1:\:/16 via fec0:\:1"
 carol::ipsec start
 moon::ipsec start
 carol::sleep 2
diff --git a/testing/tests/ipv6/rw-ikev2/description.txt b/testing/tests/ipv6/rw-ikev2/description.txt
new file mode 100644 (file)
index 0000000..1746137
--- /dev/null
@@ -0,0 +1,7 @@
+The roadwarriors <b>carol</b> and <b>dave</b> set up an IPv6 connection each 
+to gateway <b>moon</b>. The authentication is based on <b>X.509 certificates</b>.
+Upon the successful establishment of the IPv6 ESP tunnels, <b>leftfirewall=yes</b>
+automatically inserts ip6tables-based firewall rules that let pass the tunneled traffic.
+In order to test both tunnel and firewall, both <b>carol</b> and <b>dave</b> send
+an IPv6 ICMP request to the client <b>alice</b> behind the gateway <b>moon</b>
+using the ping6 command.
diff --git a/testing/tests/ipv6/rw-ikev2/evaltest.dat b/testing/tests/ipv6/rw-ikev2/evaltest.dat
new file mode 100644 (file)
index 0000000..cee1853
--- /dev/null
@@ -0,0 +1,10 @@
+moon::ipsec statusall::rw.*ESTABLISHED::YES
+carol::ipsec statusall::home.*ESTABLISHED::YES
+dave::ipsec statusall::home.*ESTABLISHED::YES
+carol::ping6 -c 1 ip6-alice.strongswan.org::64 bytes from ip6-alice.strongswan.org: icmp_seq=1::YES
+dave::ping6 -c 1 ip6-alice.strongswan.org::64 bytes from ip6-alice.strongswan.org: icmp_seq=1::YES
+moon::tcpdump::IP6 ip6-carol.strongswan.org > ip6-moon.strongswan.org: ESP::YES
+moon::tcpdump::IP6 ip6-moon.strongswan.org > ip6-carol.strongswan.org: ESP::YES
+moon::tcpdump::IP6 ip6-dave.strongswan.org > ip6-moon.strongswan.org: ESP::YES
+moon::tcpdump::IP6 ip6-moon.strongswan.org > ip6-dave.strongswan.org: ESP::YES
+
diff --git a/testing/tests/ipv6/rw-ikev2/hosts/carol/etc/init.d/iptables b/testing/tests/ipv6/rw-ikev2/hosts/carol/etc/init.d/iptables
new file mode 100755 (executable)
index 0000000..03fdd4a
--- /dev/null
@@ -0,0 +1,107 @@
+#!/sbin/runscript
+# Copyright 1999-2004 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+opts="start stop reload"
+
+depend() {
+       before net
+       need logger
+}
+
+start() {
+       ebegin "Starting firewall"
+
+       # enable IP forwarding
+       echo 1 > /proc/sys/net/ipv6/conf/all/forwarding
+       echo 1 > /proc/sys/net/ipv4/ip_forward
+       
+       # default policy is DROP
+       /sbin/iptables -P INPUT DROP
+       /sbin/iptables -P OUTPUT DROP
+       /sbin/iptables -P FORWARD DROP
+
+       /sbin/ip6tables -P INPUT DROP
+       /sbin/ip6tables -P OUTPUT DROP
+       /sbin/ip6tables -P FORWARD DROP
+
+       # allow esp
+       ip6tables -A INPUT  -i eth0 -p 50 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p 50 -j ACCEPT
+
+       # allow IKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 500 --dport 500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 500 --sport 500 -j ACCEPT
+
+       # allow MobIKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 4500 --dport 4500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 4500 --sport 4500 -j ACCEPT
+
+       # allow last UDP fragment
+       ip6tables -A INPUT -i eth0 -p udp -m frag --fraglast -j ACCEPT
+
+       # allow ICMPv6 neighbor-solicitations
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       
+       # allow ICMPv6 neighbor-advertisements
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+
+       # allow crl fetch from winnetou
+       iptables -A INPUT  -i eth0 -p tcp --sport 80 -s PH_IP_WINNETOU -j ACCEPT
+       iptables -A OUTPUT -o eth0 -p tcp --dport 80 -d PH_IP_WINNETOU -j ACCEPT
+
+       # allow ssh
+       iptables -A INPUT  -p tcp --dport 22 -j ACCEPT
+       iptables -A OUTPUT -p tcp --sport 22 -j ACCEPT
+
+       # log dropped packets
+       ip6tables -A INPUT  -j LOG --log-prefix " IN: "
+       ip6tables -A OUTPUT -j LOG --log-prefix " OUT: "
+
+       eend $?
+}
+
+stop() {
+       ebegin "Stopping firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+
+                       /sbin/ipables -F -t $a
+                       /sbin/iptables -X -t $a
+       
+                       if [ $a == nat ]; then
+                               /sbin/iptables -t nat -P PREROUTING ACCEPT
+                               /sbin/iptables -t nat -P POSTROUTING ACCEPT
+                               /sbin/iptables -t nat -P OUTPUT ACCEPT
+                       elif [ $a == mangle ]; then
+                               /sbin/iptables -t mangle -P PREROUTING ACCEPT
+                               /sbin/iptables -t mangle -P INPUT ACCEPT
+                               /sbin/iptables -t mangle -P FORWARD ACCEPT
+                               /sbin/iptables -t mangle -P OUTPUT ACCEPT
+                               /sbin/iptables -t mangle -P POSTROUTING ACCEPT
+                       elif [ $a == filter ]; then
+                               /sbin/ip6tables -t filter -P INPUT ACCEPT
+                               /sbin/ip6tables -t filter -P FORWARD ACCEPT
+                               /sbin/ip6tables -t filter -P OUTPUT ACCEPT
+
+                               /sbin/iptables -t filter -P INPUT ACCEPT
+                               /sbin/iptables -t filter -P FORWARD ACCEPT
+                               /sbin/iptables -t filter -P OUTPUT ACCEPT
+                       fi
+               done
+       eend $?
+}
+
+reload() {
+       ebegin "Flushing firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+               done;
+        eend $?
+       start
+}
+
diff --git a/testing/tests/ipv6/rw-ikev2/hosts/carol/etc/ipsec.conf b/testing/tests/ipv6/rw-ikev2/hosts/carol/etc/ipsec.conf
new file mode 100755 (executable)
index 0000000..9238858
--- /dev/null
@@ -0,0 +1,23 @@
+# /etc/ipsec.conf - strongSwan IPsec configuration file
+
+config setup
+        crlcheckinterval=180
+       strictcrlpolicy=no
+       plutostart=no
+
+conn %default
+       ikelifetime=60m
+       keylife=20m
+       rekeymargin=3m
+       keyingtries=1
+
+conn home
+       left=PH_IP6_CAROL
+       leftcert=carolCert.pem
+       leftid=carol@strongswan.org
+       leftfirewall=yes
+       right=PH_IP6_MOON
+       rightid=@moon.strongswan.org
+       rightsubnet=fec1::/16
+       keyexchange=ikev2
+       auto=add
diff --git a/testing/tests/ipv6/rw-ikev2/hosts/dave/etc/init.d/iptables b/testing/tests/ipv6/rw-ikev2/hosts/dave/etc/init.d/iptables
new file mode 100755 (executable)
index 0000000..03fdd4a
--- /dev/null
@@ -0,0 +1,107 @@
+#!/sbin/runscript
+# Copyright 1999-2004 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+opts="start stop reload"
+
+depend() {
+       before net
+       need logger
+}
+
+start() {
+       ebegin "Starting firewall"
+
+       # enable IP forwarding
+       echo 1 > /proc/sys/net/ipv6/conf/all/forwarding
+       echo 1 > /proc/sys/net/ipv4/ip_forward
+       
+       # default policy is DROP
+       /sbin/iptables -P INPUT DROP
+       /sbin/iptables -P OUTPUT DROP
+       /sbin/iptables -P FORWARD DROP
+
+       /sbin/ip6tables -P INPUT DROP
+       /sbin/ip6tables -P OUTPUT DROP
+       /sbin/ip6tables -P FORWARD DROP
+
+       # allow esp
+       ip6tables -A INPUT  -i eth0 -p 50 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p 50 -j ACCEPT
+
+       # allow IKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 500 --dport 500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 500 --sport 500 -j ACCEPT
+
+       # allow MobIKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 4500 --dport 4500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 4500 --sport 4500 -j ACCEPT
+
+       # allow last UDP fragment
+       ip6tables -A INPUT -i eth0 -p udp -m frag --fraglast -j ACCEPT
+
+       # allow ICMPv6 neighbor-solicitations
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       
+       # allow ICMPv6 neighbor-advertisements
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+
+       # allow crl fetch from winnetou
+       iptables -A INPUT  -i eth0 -p tcp --sport 80 -s PH_IP_WINNETOU -j ACCEPT
+       iptables -A OUTPUT -o eth0 -p tcp --dport 80 -d PH_IP_WINNETOU -j ACCEPT
+
+       # allow ssh
+       iptables -A INPUT  -p tcp --dport 22 -j ACCEPT
+       iptables -A OUTPUT -p tcp --sport 22 -j ACCEPT
+
+       # log dropped packets
+       ip6tables -A INPUT  -j LOG --log-prefix " IN: "
+       ip6tables -A OUTPUT -j LOG --log-prefix " OUT: "
+
+       eend $?
+}
+
+stop() {
+       ebegin "Stopping firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+
+                       /sbin/ipables -F -t $a
+                       /sbin/iptables -X -t $a
+       
+                       if [ $a == nat ]; then
+                               /sbin/iptables -t nat -P PREROUTING ACCEPT
+                               /sbin/iptables -t nat -P POSTROUTING ACCEPT
+                               /sbin/iptables -t nat -P OUTPUT ACCEPT
+                       elif [ $a == mangle ]; then
+                               /sbin/iptables -t mangle -P PREROUTING ACCEPT
+                               /sbin/iptables -t mangle -P INPUT ACCEPT
+                               /sbin/iptables -t mangle -P FORWARD ACCEPT
+                               /sbin/iptables -t mangle -P OUTPUT ACCEPT
+                               /sbin/iptables -t mangle -P POSTROUTING ACCEPT
+                       elif [ $a == filter ]; then
+                               /sbin/ip6tables -t filter -P INPUT ACCEPT
+                               /sbin/ip6tables -t filter -P FORWARD ACCEPT
+                               /sbin/ip6tables -t filter -P OUTPUT ACCEPT
+
+                               /sbin/iptables -t filter -P INPUT ACCEPT
+                               /sbin/iptables -t filter -P FORWARD ACCEPT
+                               /sbin/iptables -t filter -P OUTPUT ACCEPT
+                       fi
+               done
+       eend $?
+}
+
+reload() {
+       ebegin "Flushing firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+               done;
+        eend $?
+       start
+}
+
diff --git a/testing/tests/ipv6/rw-ikev2/hosts/dave/etc/ipsec.conf b/testing/tests/ipv6/rw-ikev2/hosts/dave/etc/ipsec.conf
new file mode 100755 (executable)
index 0000000..ed1eb39
--- /dev/null
@@ -0,0 +1,23 @@
+# /etc/ipsec.conf - strongSwan IPsec configuration file
+
+config setup
+        crlcheckinterval=180
+       strictcrlpolicy=no
+       plutostart=no
+
+conn %default
+       ikelifetime=60m
+       keylife=20m
+       rekeymargin=3m
+       keyingtries=1
+
+conn home
+       left=PH_IP6_DAVE
+       leftcert=daveCert.pem
+       leftid=dave@strongswan.org
+       leftfirewall=yes
+       right=PH_IP6_MOON
+       rightid=@moon.strongswan.org
+       rightsubnet=fec1::/16
+       keyexchange=ikev2
+       auto=add
diff --git a/testing/tests/ipv6/rw-ikev2/hosts/moon/etc/init.d/iptables b/testing/tests/ipv6/rw-ikev2/hosts/moon/etc/init.d/iptables
new file mode 100755 (executable)
index 0000000..03fdd4a
--- /dev/null
@@ -0,0 +1,107 @@
+#!/sbin/runscript
+# Copyright 1999-2004 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+opts="start stop reload"
+
+depend() {
+       before net
+       need logger
+}
+
+start() {
+       ebegin "Starting firewall"
+
+       # enable IP forwarding
+       echo 1 > /proc/sys/net/ipv6/conf/all/forwarding
+       echo 1 > /proc/sys/net/ipv4/ip_forward
+       
+       # default policy is DROP
+       /sbin/iptables -P INPUT DROP
+       /sbin/iptables -P OUTPUT DROP
+       /sbin/iptables -P FORWARD DROP
+
+       /sbin/ip6tables -P INPUT DROP
+       /sbin/ip6tables -P OUTPUT DROP
+       /sbin/ip6tables -P FORWARD DROP
+
+       # allow esp
+       ip6tables -A INPUT  -i eth0 -p 50 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p 50 -j ACCEPT
+
+       # allow IKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 500 --dport 500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 500 --sport 500 -j ACCEPT
+
+       # allow MobIKE
+       ip6tables -A INPUT  -i eth0 -p udp --sport 4500 --dport 4500 -j ACCEPT
+       ip6tables -A OUTPUT -o eth0 -p udp --dport 4500 --sport 4500 -j ACCEPT
+
+       # allow last UDP fragment
+       ip6tables -A INPUT -i eth0 -p udp -m frag --fraglast -j ACCEPT
+
+       # allow ICMPv6 neighbor-solicitations
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-solicitation -j ACCEPT
+       
+       # allow ICMPv6 neighbor-advertisements
+       ip6tables -A INPUT  -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+       ip6tables -A OUTPUT -p icmpv6 --icmpv6-type neighbor-advertisement -j ACCEPT
+
+       # allow crl fetch from winnetou
+       iptables -A INPUT  -i eth0 -p tcp --sport 80 -s PH_IP_WINNETOU -j ACCEPT
+       iptables -A OUTPUT -o eth0 -p tcp --dport 80 -d PH_IP_WINNETOU -j ACCEPT
+
+       # allow ssh
+       iptables -A INPUT  -p tcp --dport 22 -j ACCEPT
+       iptables -A OUTPUT -p tcp --sport 22 -j ACCEPT
+
+       # log dropped packets
+       ip6tables -A INPUT  -j LOG --log-prefix " IN: "
+       ip6tables -A OUTPUT -j LOG --log-prefix " OUT: "
+
+       eend $?
+}
+
+stop() {
+       ebegin "Stopping firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+
+                       /sbin/ipables -F -t $a
+                       /sbin/iptables -X -t $a
+       
+                       if [ $a == nat ]; then
+                               /sbin/iptables -t nat -P PREROUTING ACCEPT
+                               /sbin/iptables -t nat -P POSTROUTING ACCEPT
+                               /sbin/iptables -t nat -P OUTPUT ACCEPT
+                       elif [ $a == mangle ]; then
+                               /sbin/iptables -t mangle -P PREROUTING ACCEPT
+                               /sbin/iptables -t mangle -P INPUT ACCEPT
+                               /sbin/iptables -t mangle -P FORWARD ACCEPT
+                               /sbin/iptables -t mangle -P OUTPUT ACCEPT
+                               /sbin/iptables -t mangle -P POSTROUTING ACCEPT
+                       elif [ $a == filter ]; then
+                               /sbin/ip6tables -t filter -P INPUT ACCEPT
+                               /sbin/ip6tables -t filter -P FORWARD ACCEPT
+                               /sbin/ip6tables -t filter -P OUTPUT ACCEPT
+
+                               /sbin/iptables -t filter -P INPUT ACCEPT
+                               /sbin/iptables -t filter -P FORWARD ACCEPT
+                               /sbin/iptables -t filter -P OUTPUT ACCEPT
+                       fi
+               done
+       eend $?
+}
+
+reload() {
+       ebegin "Flushing firewall"
+               for a in `cat /proc/net/ip_tables_names`; do
+                       /sbin/ip6tables -F -t $a
+                       /sbin/ip6tables -X -t $a
+               done;
+        eend $?
+       start
+}
+
diff --git a/testing/tests/ipv6/rw-ikev2/hosts/moon/etc/ipsec.conf b/testing/tests/ipv6/rw-ikev2/hosts/moon/etc/ipsec.conf
new file mode 100755 (executable)
index 0000000..f78ba45
--- /dev/null
@@ -0,0 +1,22 @@
+# /etc/ipsec.conf - strongSwan IPsec configuration file
+
+config setup
+        crlcheckinterval=180
+       strictcrlpolicy=no
+       plutostart=no
+
+conn %default
+       ikelifetime=60m
+       keylife=20m
+       rekeymargin=3m
+       keyingtries=1
+
+conn rw
+       left=PH_IP6_MOON
+       leftcert=moonCert.pem
+       leftid=@moon.strongswan.org
+       leftsubnet=fec1::/16
+       leftfirewall=yes
+       right=%any
+       keyexchange=ikev2
+       auto=add
diff --git a/testing/tests/ipv6/rw-ikev2/posttest.dat b/testing/tests/ipv6/rw-ikev2/posttest.dat
new file mode 100644 (file)
index 0000000..07e89d7
--- /dev/null
@@ -0,0 +1,9 @@
+moon::ipsec stop
+carol::ipsec stop
+dave::ipsec stop
+moon::/etc/init.d/iptables stop 2> /dev/null
+carol::/etc/init.d/iptables stop 2> /dev/null
+dave::/etc/init.d/iptables stop 2> /dev/null
+alice::"ip route del fec0:\:/16 via fec1:\:1"
+carol::"ip route del fec1:\:/16 via fec0:\:1"
+dave::"ip route del fec1:\:/16 via fec0:\:1"
diff --git a/testing/tests/ipv6/rw-ikev2/pretest.dat b/testing/tests/ipv6/rw-ikev2/pretest.dat
new file mode 100644 (file)
index 0000000..dea60a0
--- /dev/null
@@ -0,0 +1,12 @@
+moon::/etc/init.d/iptables start 2> /dev/null
+carol::/etc/init.d/iptables start 2> /dev/null
+dave::/etc/init.d/iptables start 2> /dev/null
+alice::"ip route add fec0:\:/16 via fec1:\:1"
+carol::"ip route add fec1:\:/16 via fec0:\:1"
+dave::"ip route add fec1:\:/16 via fec0:\:1"
+moon::ipsec start
+carol::ipsec start
+dave::ipsec start
+carol::sleep 1
+carol::ipsec up home
+dave::ipsec up home
diff --git a/testing/tests/ipv6/rw-ikev2/test.conf b/testing/tests/ipv6/rw-ikev2/test.conf
new file mode 100644 (file)
index 0000000..7041682
--- /dev/null
@@ -0,0 +1,21 @@
+#!/bin/bash
+#
+# This configuration file provides information on the
+# UML instances used for this test
+
+# All UML instances that are required for this test
+#
+UMLHOSTS="alice moon carol winnetou dave"
+
+# Corresponding block diagram
+#
+DIAGRAM="a-m-c-w-d.png"
+
+# UML instances on which tcpdump is to be started
+#
+TCPDUMPHOSTS="moon"
+
+# UML instances on which IPsec is started
+# Used for IPsec logging purposes
+#
+IPSECHOSTS="moon carol dave"